The 2014 ACM-ICPC Asia Regional Anshan
继续复盘下一场Regional!
【A】-_-///
【B】模拟(之前每次遇到模拟、暴搜都直接跳了,题目太长也是一个原因...下次是在不行可以尝试一下)
【C】数论 互质、容斥?
【F】-_-///
【G】最小割的灵活运用
【H】搜索+打表
【J】-_-///
【K】计算几何、置换群(Polya计数)
【L】AC自动机+树链剖分
【D】 HDU 5073
Galaxy
Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 262144/262144 K (Java/Others)
Special Judge
Everything runs well except one thing. DRD thinks that the galaxy rotates too slow. As we know, to increase the angular speed with the same angular momentum, we have to decrease the moment of inertia.
The moment of inertia I of a set of n stars can be calculated with the formulawhere wi is the weight of star i, di is the distance form star i to the mass of center.
As DRD’s friend, ATM, who bought M78 Galaxy, wants to help him. ATM creates some black holes and white holes so that he can transport stars in a negligible time. After transportation, the n stars will also rotate around their new center of mass. Due to financial pressure, ATM can only transport at most k stars. Since volumes of the stars are negligible, two or more stars can be transported to the same position.
Now, you are supposed to calculate the minimum moment of inertia after transportation.
For each test case, the first line contains two integers, n(1 ≤ n ≤ 50000) and k(0 ≤ k ≤ n), as mentioned above. The next line contains n integers representing the positions of the stars. The absolute values of positions will be no more than 50000.
- - -
【Sample Output】
0.5
【题意】
平面中有n个点,最多可以移动k个点,使原题条件中的I达到最小值。物理题,计算转动惯量。
【分析】
开始的时候真是死活看不懂题......
原题中的wi始终为1,即可忽略,然后di指的是x距离所有点重心的距离,这里的重心即是所有点坐标的平均值了。所以原式可以写成这样:
分析一下这个东西跟方差很像,所以可以写成:
然后:
最后:
基本的I的计算方法就推导出来了,接下来是k的问题。
为了让I尽可能的小,也就是让方差尽可能的小,那么最佳的方案就是把距离重心最远的k个点都移到重心去。则首先根据坐标排序,从两端开始枚举取数,前面取i个那最后就取k-i个,找到一种最佳的取数方案把最外围的点都移掉即可。
/* ***********************************************
MYID : Chen Fan
LANG : G++
PROG : HDU 5073
************************************************ */ #include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm> using namespace std; long long a[],sum[],sum2[]; int main()
{
int t;
scanf("%d",&t);
for (int tt=;tt<=t;tt++)
{
int n,k;
scanf("%d%d",&n,&k); for (int i=;i<=n;i++) scanf("%lld",&a[i]); if (n==k)
{
printf("0\n");
continue;
} sort(&a[],&a[n+]);
memset(sum,,sizeof(sum));
memset(sum2,,sizeof(sum2));
for (int i=;i<=n;i++)
{
sum[i]=sum[i-]+a[i];
sum2[i]=sum2[i-]+a[i]*a[i];
} double mi=sum2[n-k]-(double)sum[n-k]*sum[n-k]/(n-k);
for (int i=;i<=k;i++)
{
double temp=sum2[n-k+i]-sum2[i]-(double)(sum[n-k+i]-sum[i])*(sum[n-k+i]-sum[i])/(n-k);
if (mi>temp) mi=temp;
} printf("%.10f\n",mi);
} return ;
}
杭电上%lld和%I64d老是出问题...%lld提交通不过的话改成%I64d应该就可以了
【E】 HDU 5074
Hatsune Miku
Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 262144/262144 K (Java/Others)
Today you want to compose a song, which is just a sequence of notes. There are only m different notes provided in the package. And you want to make a song with n notes.Also, you know that there is a system to evaluate the beautifulness of a song. For each two consecutive notes a and b, if b comes after a, then the beautifulness for these two notes is evaluated as score(a, b).
So the total beautifulness for a song consisting of notes a1, a2, . . . , an, is simply the sum of score(ai, ai+1) for 1 ≤ i ≤ n - 1.
Now, you find that at some positions, the notes have to be some specific ones, but at other positions you can decide what notes to use. You want to maximize your song’s beautifulness. What is the maximum beautifulness you can achieve?
For each test case, the first line contains two integers n(1 ≤ n ≤ 100) and m(1 ≤ m ≤ 50) as mentioned above. Then m lines follow, each of them consisting of m space-separated integers, the j-th integer in the i-th line for score(i, j)( 0 ≤ score(i, j) ≤ 100). The next line contains n integers, a1, a2, . . . , an (-1 ≤ ai ≤ m, ai ≠ 0), where positive integers stand for the notes you cannot change, while negative integers are what you can replace with arbitrary notes. The notes are named from 1 to m.
- - - - - - -
【Sample Output】
【分析】
简单的签到DP,f(i,j)表示摆到第i个符号,且最后一个取j的最大分数,则f(i,j)=max(f(i-1,k)+score(k,j))
/* ***********************************************
MYID : Chen Fan
LANG : G++
PROG : HDU 5074
************************************************ */ #include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm> using namespace std; int a[];
int f[][];
int score[][]; int main()
{
int t;
scanf("%d",&t);
for (int tt=;tt<=t;tt++)
{
int n,m;
scanf("%d%d",&n,&m); memset(score,,sizeof(score));
for (int i=;i<=m;i++)
for (int j=;j<=m;j++) scanf("%d",&score[i][j]); for (int i=;i<=n;i++) scanf("%d",&a[i]); memset(f,,sizeof(f));
for (int i=;i<=n;i++)
{
if (a[i]>)
if (a[i-]>) f[i][a[i]]=f[i-][a[i-]]+score[a[i-]][a[i]];
else for (int j=;j<=m;j++)
f[i][a[i]]=max(f[i][a[i]],f[i-][j]+score[j][a[i]]);
else
if (a[i-]>)
for (int j=;j<=m;j++) f[i][j]=f[i-][a[i-]]+score[a[i-]][j];
else for (int j=;j<=m;j++)
for (int k=;k<=m;k++) f[i][j]=max(f[i][j],f[i-][k]+score[k][j]);
} if (a[n]>) printf("%d\n",f[n][a[n]]);
else
{
int ma=;
for (int i=;i<=m;i++)
if (ma<f[n][i]) ma=f[n][i];
printf("%d\n",ma);
}
} return ;
}
【I】 HDU 5078
Osu!
Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 262144/262144 K (Java/Others)
Special Judge
To simplify the things, in a game consisting of N points, point i will occur at time ti at place (xi, yi), and you should click it exactly at ti at (xi, yi). That means you should move your cursor from point i to point i+1. This movement is called a jump, and the difficulty of a jump is just the distance between point i and point i+1 divided by the time between ti and ti+1. And the difficulty of a game is simply the difficulty of the most difficult jump in the game.
Now, given a description of a game, please calculate its difficulty.
For each test case, the first line contains an integer N (2 ≤ N ≤ 1000) denoting the number of the points in the game. Then N lines follow, the i-th line consisting of 3 space-separated integers, ti(0 ≤ ti < ti+1 ≤ 106), xi, and yi (0 ≤ xi, yi ≤ 106) as mentioned above.
Your answer will be considered correct if and only if its absolute or relative error is less than 1e-9.
【Sample Output】
9.2195444573
54.5893762558
【分析】
签到题,唯一要注意的是数据范围,两个1e6数量级的数相乘有超int的可能。
The 2014 ACM-ICPC Asia Regional Anshan的更多相关文章
- HDU 5000 2014 ACM/ICPC Asia Regional Anshan Online DP
Clone Time Limit : 2000/1000ms (Java/Other) Memory Limit : 65536/65536K (Java/Other) Total Submiss ...
- 2014 ACM/ICPC Asia Regional Anshan Online
默默的签到 Osu! http://acm.hdu.edu.cn/showproblem.php?pid=5003 #include<cstdio> #include<algorit ...
- HDU 5002 Tree(动态树LCT)(2014 ACM/ICPC Asia Regional Anshan Online)
Problem Description You are given a tree with N nodes which are numbered by integers 1..N. Each node ...
- HDU 5000 Clone(离散数学+DP)(2014 ACM/ICPC Asia Regional Anshan Online)
Problem Description After eating food from Chernobyl, DRD got a super power: he could clone himself ...
- hdu 5016 点分治(2014 ACM/ICPC Asia Regional Xi'an Online)
Mart Master II Time Limit: 12000/6000 MS (Java/Others) Memory Limit: 65536/65536 K (Java/Others)T ...
- HDU 5029 Relief grain(离线+线段树+启发式合并)(2014 ACM/ICPC Asia Regional Guangzhou Online)
题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=5029 Problem Description The soil is cracking up beca ...
- 2014 ACM/ICPC Asia Regional Shanghai Online
Tree http://acm.hdu.edu.cn/showproblem.php?pid=5044 树链剖分,区间更新的时候要用on的左++右--的标记方法,要手动扩栈,用c++交,综合以上的条件 ...
- 2014 ACM/ICPC Asia Regional Guangzhou Online
Wang Xifeng's Little Plot http://acm.hdu.edu.cn/showproblem.php?pid=5024 预处理出每个点八个方向能走的最远距离,然后枚举起点,枚 ...
- 2014 ACM/ICPC Asia Regional 北京 Online
G - Grade Ted is a employee of Always Cook Mushroom (ACM). His boss Matt gives him a pack of mushroo ...
- 2014 ACM/ICPC Asia Regional Xi'an Online
03 hdu5009 状态转移方程很好想,dp[i] = min(dp[j]+o[j~i]^2,dp[i]) ,o[j~i]表示从j到i颜色的种数. 普通的O(n*n)是会超时的,可以想到o[]最大为 ...
随机推荐
- Validation of viewstate MAC failed machinekey生成、使用方法
前段时间公司为了减轻服务器压力,对网页做了集群,分布在多台服务器,通过DNS轮回解析到各台服务器,结果页面只要打开停留到DNS解析到下一个地址,就会出现出下错误信息. Validation of vi ...
- EXP AND IMP
purpors: exp pro data to uat data exp and imp will not create user expdp and impdp will create user ...
- C++11 左值与右值
概念 左值:表达式结束后依然存在的对象 右值:表达式结束后就不存在的临时对象 2.如何判断左值和右值 能不能对表达式取地址,如果能,就是左值,否则就是右值 3.对下面的语句进行区分 int a = 3 ...
- java解析XML获取城市代码
运行前先导入dom4j架包,由于我们公司用的代理服务器所以下面我设置了代理ip,不需要的可直接忽略 package com.chengshidaima.tools; import java.io.Bu ...
- HDOJ3743<分治>
题意:求一个排列的逆序数. #include<cstdio> #include<iostream> #include<algorithm> const int ma ...
- php des 加密类
<?php/** *@see Yii CSecurityManager; */class Des{ public static function encrypt($data,$key){ $mo ...
- UIImagePickerController 相关
UIImagePickerController是系统封装好的一个导航视图控制器,使用其开发者可以十分方便的进行相机相册相关功能的调用.UIImagePickerController继承于UINavig ...
- Firebase 相关
谷歌在 2016年 I/O 大会上推出了 Firebase 的新版本.Firebase 平台提供了为移动端(iOS和Android)和 Web 端创建后端架构的完整解决方案. 从一开始的移动后端即服务 ...
- 单独谈谈 Android Cursor 的使用细节
使用过 SQLite 数据库对 Cursor 应该不陌生,这里单独拿出来谈一下,加深对Android SQLite中使用 Cursor 的理解. 在你理解和使用 Android Cursor 的时候你 ...
- java 随机流
Example10_8.java import java.io.*; public class Example10_8 { public static void main(String args[]) ...